<?php
/*
Plugin Name: Navayan Subscribe
Plugin URI: http://blog.navayan.com/
Description: Navayan Subscribe allows your website/blog visitor to easily and quickly register to your website/blog using email, name and additional field.
Author: Amol Nirmala Waman
Version: 1.0
Author URI: http://blog.navayan.com/
Usage: Paste this single line code within PHP tag in your template: if ( function_exists('navayan_subscribe') ){ echo navayan_subscribe(); }
*/

include('ny-subscribe-define.php');

/************************ ADMIN MENU UNDER 'TOOLS' TAB *********************/
function ny_subscribe_init() {
	if (function_exists('add_options_page')) {
		add_management_page( __( NY_PLUGIN_SUBSCRIBE_NAME, NY_PLUGIN_SUBSCRIBE_SLUG), __( NY_PLUGIN_SUBSCRIBE_NAME, NY_PLUGIN_SUBSCRIBE_SLUG), 'manage_options', NY_PLUGIN_SUBSCRIBE_SLUG, 'ny_subscribe_admin');
	}
}
add_action('admin_menu','ny_subscribe_init');
/************************ ADMIN MENU UNDER 'TOOLS' TAB ENDS *********************/

$admin_fields = array(
	array(
		'slug'	=> 'ny_subscribe_field_form_heading',
		'type'	=> 'text',
		'label'	=> 'Form Heading',
		'val'		=> 'Subscribe'
	),
	array(
		'slug'	=> 'ny_subscribe_field_label',
		'type'	=> 'text',
		'label'	=> 'Submit Button text',
		'val'		=> 'Subscribe'
	),
	array(
		'slug'	=> 'ny_subscribe_field_show_name',
		'type'	=> 'checkbox',
		'label'	=> 'Display Name field?',
		'val'		=> 0
	),
	array(
		'slug'	=> 'ny_subscribe_field_custom',
		'type'	=> 'text',
		'label'	=> 'Type Custom field you want to display',
		'val'		=> ''
	),
	array(
		'slug'	=> 'ny_subscribe_field_email_invalid',
		'type'	=> 'text',
		'label'	=> 'Invalid email message',
		'val'		=> 'Invalid Email'
	),
	array(
		'slug'	=> 'ny_subscribe_field_email_exist',
		'type'	=> 'text',
		'label'	=> 'Email exist message',
		'val'		=> 'This Email already registered'
	),
	array(
		'slug'	=> 'ny_subscribe_field_success',
		'type'	=> 'text',
		'label'	=> 'Success message',
		'val'		=> 'Thank you for subscribing!'
	),
	array(
		'slug'	=> 'ny_subscribe_field_hide_form',
		'type'	=> 'checkbox',
		'label'	=> 'Hide form after success?',
		'val'		=> 1
	)		
);

/************************ EXTEND USERMETA **************************/
function ny_subscribe_extend_contact( $contactmethods ) {
  $contactmethods[ 'ny_subscribe_field_custom' ] = get_option( 'ny_subscribe_field_custom' );
  return $contactmethods;
}
add_filter('user_contactmethods','ny_subscribe_extend_contact',10,1);
/************************ EXTEND USERMETA ENDS **************************/

/************************ GLOBAL VARS **************************/
$init_global = array();
$init_global['form_heading']	= get_option( 'ny_subscribe_field_form_heading' )		? get_option( 'ny_subscribe_field_form_heading' ) : 'Subscribe';
$init_global['submit_label']	= get_option( 'ny_subscribe_field_label' )					? get_option( 'ny_subscribe_field_label' ) : 'Subscribe';
$init_global['show_name']			= get_option( 'ny_subscribe_field_show_name' );
$init_global['show_custom']		= get_option( 'ny_subscribe_field_custom' );
$init_global['email_error']		= get_option( 'ny_subscribe_field_email_invalid' )	? get_option( 'ny_subscribe_field_email_invalid' ) : 'Invalid Email';
$init_global['email_exist']		= get_option( 'ny_subscribe_field_email_exist' )		? get_option( 'ny_subscribe_field_email_exist' ) : 'This Email already registered';
$init_global['msg_success']		= get_option( 'ny_subscribe_field_success' )				? get_option( 'ny_subscribe_field_success' ) : 'Thank you for subscribing!';

$val_name=''; $val_email=''; $val_custom='';
/************************ GLOBAL VARS ENDS **************************/

/************************ FORM FIELDS **************************/
function ny_subscribe_form_fields(){
	global $val_name, $val_email, $val_custom, $init_global;
	
	if( $init_global['show_name'] == 1){
		echo "<p>
			<label for='ny_name'>Name</label>
			<input type='text' name='ny_name' id='ny_name' value='". $val_name ."' />
		</p>";
	}
	
	echo "<p>
		<label for='ny_email'>Email</label>
		<input type='text' name='ny_email' id='ny_email' value='". $val_email ."' />
	</p>";
	
	if( $init_global['show_custom'] ){
		echo "<p>
			<label for='ny_custom'>". $init_global['show_custom'] ."</label>
			<input type='text' name='ny_custom' id='ny_custom' value='". $val_custom ."' />
		</p>";
	}
	
}
/************************ FORM FIELDS ENDS **************************/

function add_subscriber($add = true){
		global $val_name, $val_email, $val_custom, $init_global;
		$return='';
		
		/************************** VALIDATING FORM AND SAVING IT INTO DB ********************/
		if( isset($_POST['ny_subscribe_submit']) ){
			require_once( ABSPATH . WPINC . '/formatting.php');
			require_once( ABSPATH . WPINC . '/user.php');
			
			$val_email	= isset($_POST['ny_email']) ? $_POST['ny_email'] : '';
			if( $init_global['show_name'] == 1){ 
				$val_name		= isset($_POST['ny_name']) ? $_POST['ny_name'] : '';
			}
			if( $init_global['show_custom'] ){
				$val_custom	= isset($_POST['ny_custom']) ? $_POST['ny_custom'] : '';
			}
				
			if ( !is_email( $val_email ) ) {
				$return['err'] = true;
				$return['msg'] = $init_global['email_error'];
			} elseif ( email_exists( $val_email ) ){			
				$return['err'] = true;
				$return['msg'] = $init_global['email_exist'];
			} else {
				
				if ( $init_global['show_name'] == 1 && $val_name == ''){
					$return['err'] = true;
					$return['msg'] = 'Type name';
				} elseif ( $init_global['show_custom'] && $val_custom == ''){					
					$return['err'] = true;
					$return['msg'] = 'Required '. $init_global['show_custom'];
				} else {
						
						$val_name			= mysql_real_escape_string($val_name);
						$val_custom		= sanitize_user( str_replace('@','', $val_custom ) );
						$clean_login	= sanitize_user( str_replace('@','', $val_email) );
						
						$val_pass			= substr( md5( uniqid( microtime() ) ), 0, 7);
						$val_id				= wp_create_user( $clean_login, $val_pass, $val_email );
						$user = new WP_User($val_id);
						$user->set_role('subscriber');
						
						if ( !$val_id ){
							$return['err'] = true;
							$return['msg'] = 'Unable to subscribe';
						}else{
							update_user_meta( $user->ID, 'ny_subscribe_field_custom', $val_custom );
							update_user_meta( $user->ID, 'first_name', $val_name );
							
							$return['err'] = false;
							$return['msg'] = $add == true ? 'Subscriber added!' : $init_global['msg_success'];
						}
				}
			}
			
			$cls = $return['err'] == true ? 'nys-error' : 'nys-success';
			echo '<p class="'.$cls.' nybox"> '. $return['msg'] .' </p>';
			if($return['err'] == false && $add == false){
				if(get_option( 'ny_subscribe_field_hide_form' ) == 1){
					echo '<style type="text/css">#ny_subscribe_form{display:none}</style>';
				}
				echo '<script type="text/javascript">
								if(jQuery){
									var jQuery = jQuery.noConflict();
									jQuery(function (){
										jQuery("#ny_subscribe_form input:text").val("");
									});
								}
							</script>';
			}
				
		}
}# add_subscriber


/************************ NAVAYAN SUBSCRIBE FORM SETTINGS **************************/
function ny_subscribe_admin() {
	global $admin_fields, $wpdb;
	$fields_count = sizeof($admin_fields);	
?>

<link rel="stylesheet" type="text/css" href="<?php echo NY_PLUGIN_SUBSCRIBE_DIR; ?>ny-admin-ui.css" />

<div id="wrapper">
	<div class="titlebg" id="plugin_title">
		<span class="head i_mange_coupon"><h1><?php echo NY_PLUGIN_SUBSCRIBE_NAME;?></h1></span>
	</div>
	<div id="page">
		<h4><?php echo NY_PLUGIN_SUBSCRIBE_INFO;?></h4>
		<div class="ny-left">						
			<div class="ny-left-widgets">				 
				<form id="ny_subscribe_admin_form" action="#wrapper" method="post">
					<fieldset class="nybox">
						<legend>Form Settings</legend>
						
						<?php
							/************************** ADD NAVAYAN SUBSCRIBE FORM FIELDS IF NOT EXIST **************************/
							for($i = 0; $i < $fields_count; $i++){
								if( !get_option( $admin_fields[$i]['slug'] ) ){
									update_option( $admin_fields[$i]['slug'], $admin_fields[$i]['val'] );
								}
							}
							
							/************************** SAVE VALUES ***************************/
							if( isset($_POST['ny_subscribe_field_submit']) ){								
								for ( $i = 0; $i < $fields_count; $i++ ){
									if ( $admin_fields[$i]['type'] == 'checkbox' ){
										$mine[$i]['value'] = isset($_POST[ $admin_fields[$i]['slug'] ]) ? 1 : 0;
									}else{
										$mine[$i]['value'] = @$_POST[$admin_fields[$i]['slug']];
									}
									update_option( $admin_fields[$i]['slug'], $mine[$i]['value'] );
								}
								echo '<p class="nys-success nybox">Settings saved!</p>';
							}
							
							/************************** DISPLAY FIELDS **************************/
							for ( $i = 0; $i < $fields_count; $i++ ){
								echo '<p>';
								echo '<label for="'. $admin_fields[$i]['slug'] .'">'. $admin_fields[$i]['label'] .'</label>';
								$checked = get_option($admin_fields[$i]['slug']) == '1' ? 'checked="checked"' : '';								
								echo '<input '. $checked .' type="'. $admin_fields[$i]['type'] .'" name="'. $admin_fields[$i]['slug'] .'" id="'. $admin_fields[$i]['slug'] .'" value="'. get_option( $admin_fields[$i]['slug'] ) .'" />';
								echo '</p>';
							}	
						?>
						
						<p>
							<label>&nbsp;</label>
							<input type="submit" name="ny_subscribe_field_submit" id="ny_subscribe_field_submit" value="Save Settings" class="button-primary" />
						</p>
					</fieldset>
				</form>
				
				
				<form id="ny_subscribe_add_form" action="#wrapper" method="post">
					<fieldset class="nybox">
						<legend>Add Subscriber</legend>
						<?php
							global $val_name, $val_email, $val_custom, $init_global;	
							add_subscriber($add = true);
							
							$u = mysql_fetch_array(mysql_query("SELECT COUNT(umeta_id) AS num FROM ".$wpdb->prefix."usermeta WHERE meta_key='".$wpdb->prefix."capabilities' AND meta_value LIKE '%subscriber%' "));
							echo "<p><b>Total subscribers: ".$u['num']."</b></p>";
						?>
						<?php ny_subscribe_form_fields(); ?>
						<p>
							<label>&nbsp;</label>
							<input type="submit" name="ny_subscribe_submit" id="ny_subscribe_submit" value="Add subscriber" class="button-primary" />
						</p>
					</fieldset>
				</form>
				
				
			</div>
    </div><!-- .ny-left -->
          
		<div class="ny-right">
			<?php if( function_exists('ny_subscribe_widgets')) ny_subscribe_widgets(); ?>
		</div><!-- .ny-right -->
		
	</div>
</div>

	
<?php
}
/************************ NAVAYAN SUBSCRIBE FORM SETTINGS ENDS **************************/


/************************** SUBSCRIBE FORM UI ********************/
if ( !function_exists('navayan_subscribe') ){	
	function navayan_subscribe(){
		wp_enqueue_style( '', NY_PLUGIN_SUBSCRIBE_DIR . 'ny-admin-ui.css' );
		$wrapper_id = 'ny_subscribe_wrapper';
		echo "<div id='". $wrapper_id ."'>";
		
		global $val_name, $val_email, $val_custom, $init_global;	
		add_subscriber($add = false);	
	
		echo "<form name='ny_subscribe_form' id='ny_subscribe_form' method='post' action='#". $wrapper_id ."'>";
		echo "<h3>". $init_global['form_heading'] ."</h3>";
		
					ny_subscribe_form_fields();
		
		echo "<p>
					<label>&nbsp;</label>
					<input type='submit' value='". $init_global['submit_label'] ."' name='ny_subscribe_submit' id='ny_subscribe_submit' />
				</p>
			</form>
		</div>";
	}
	add_shortcode('navayan_subscribe', 'navayan_subscribe');
}
/************************** SUBSCRIBE FORM UI ENDS ********************/	

?>